/* Quicksort

Vorlage: http://cprogramminglanguage.net/quicksort-algorithm-c-source-code.aspx

*/ 
 
#include <stdlib.h>
#include "LPC17xx.h"

void swap(unsigned long *x, unsigned long *y);
int choose_pivot(unsigned long i, unsigned long j);
void quicksort(unsigned long m, unsigned long n);

unsigned long const MAX_ELEMENTS = 1024;
unsigned long list[MAX_ELEMENTS];
unsigned long i = 0;

 
int main(void) {	
// generate random numbers and fill them to the list
   for(i = 0; i < MAX_ELEMENTS; i++ ) {
       list[i] = rand();
   } 
// sort the list using quicksort
   quicksort(0,MAX_ELEMENTS-1);
	while(1);
} 

void swap(unsigned long *x,unsigned long *y) {
   unsigned long temp;
   temp = *x;
   *x = *y;
   *y = temp;
}
 
int choose_pivot(unsigned long i, unsigned long j) {
   return((i+j) /2);
}
 
void quicksort(unsigned long m, unsigned long n) {
   unsigned long key, i, j, k;
   if( m < n) {
      k = choose_pivot(m,n);
      swap(&list[m],&list[k]);
      key = list[m];
      i = m+1;
      j = n;
      while(i <= j) {
         while((i <= n) && (list[i] <= key))
                i++;
         while((j >= m) && (list[j] > key))
                j--;
         if( i < j)
                swap(&list[i],&list[j]);
      }
      // swap two elements
      swap(&list[m],&list[j]);
      // recursively sort the lesser list
      quicksort(m,j-1);
      quicksort(j+1,n);
   }
}	
